#include <bits/stdc++.h>
using namespace std;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0),cout.tie(0);
    long long n , m;
    cin >> n >> m;
    long long a[n][m];
    for (long long i = 0; i < n; i++) 
        for (long long j = 0; j < m; j++) 
            cin >> a[i][j];
    long long q;
    cin >> q;
    long long b[q][2];
    for (long long i = 0; i < q; i++) {
        cin >> b[i][0] >> b[i][1];
        b[i][0] -= 1;
        b[i][1] -= 1;
    }
    int min[q];
    for(int k = 0; k < q; k++) {
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < m; j++) {
                if(j < m - 1) {
                    if(a[i+1][j] < a[i][j+1]) {
                        min[k] += a[i+1][j];
                        i++;
                    }
                    else {
                        min[k] += a[i][j+1];
                        j++;
                    }
                }
                else {
                    if(a[i][0] < a[i][j]) {
                        min[k] += a[i][0];
                        j = 0;
                        i++;
                    }
                    else {
                        min[k] += a[i][j];
                    }
                }
            }
        }
    }
    for(int k = 0; k < q; k++)
        cout << min[k] << endl;
}